%define rhelp_version 0.3.0
%define debug_package %{nil}

Name:           dd_rescue
Version:        1.99.8
Release:        1%{?dist}
Summary:        Fault tolerant "dd" utility for rescuing data from bad media
Group:          Applications/System
# No version specified
License:        GPL+
URL:            http://www.garloff.de/kurt/linux/ddrescue/
Source0:        http://www.garloff.de/kurt/linux/ddrescue/dd_rescue-%{version}.tar.bz2
Source1:        http://www.kalysto.org/pkg/dd_rhelp-%{rhelp_version}.tar.gz
BuildRoot:      %(mktemp -ud %{_tmppath}/%{name}-%{version}-%{release}-XXXXXX)
BuildRequires:	autoconf
BuildRequires:	lzo-devel

%description
ddrescue is a utility similar to the system utility "dd" which copies
data from a file or block device to another. ddrescue does however
not abort on errors in the input file. This makes it suitable for
rescuing data from media with errors, e.g. a disk with bad sectors.

This package includes dd_rhelp, a wrapper script facilitating data 
recovery.

%prep
%setup -q
tar zxf %{SOURCE1}

%build
autoconf
autoheader

%configure
make RPM_OPT_FLAGS="%{optflags}" %{?_smp_mflags}
cp -p README.dd_rescue README
cp -p dd_rhelp-%{rhelp_version}/README README.dd_rhelp
cp -p dd_rhelp-%{rhelp_version}/FAQ FAQ.dd_rhelp

%install
rm -rf %{buildroot}
make install DESTDIR=%{buildroot} MANDIR=%{buildroot}/usr/share/man INSTASROOT="" INSTALLFLAGS=""
install -D -m 755 dd_rhelp-%{rhelp_version}/dd_rhelp %{buildroot}%{_bindir}/dd_rhelp

%clean
rm -rf %{buildroot}

%files
%defattr(-,root,root,-)
%doc COPYING README README.dd_rhelp FAQ.dd_rhelp
%{_bindir}/dd_rescue
%{_bindir}/dd_rhelp
%{_libdir}/*.so
%{_mandir}/man1/%{name}.1*
%{_mandir}/man1/ddr_lzo.1.gz
%{_mandir}/man1/ddr_crypt.1.gz

%changelog
* Sun Dec  3 2017 Lawrence R. Rogers <lrr@cert.org> - 1.99.8-1
* Release 1.99.8-1
	Version 1.99.8 brings compatibility with OpenSSL-1.1.
	Trouble was that the EVP interface has significantly changed.
	Thanks got to Marcus Meissner for contributing the patch.
	I used the opportunity to structure the AES plugins a bit better; also the test_aes program now uses CPU detection and can thus be used in the check target.

* Thu Dec 29 2016 Lawrence R. Rogers <lrr@cert.org> - 1.99.5-1
* Release 1.99.5-1
	Version 1.99.5 (2016-12-29)
	  Version 1.99.5 has two compiler fixes and a better estimation (and thus better progress reporting) of the transfer length.
	  It also has a new ratecontrol feature, allowing to throttle the speed with which data gets copied.

	Version 1.99.4 (2016-08-25)
	  Version 1.99.4 has a couple of fixes on top of 1.99: A memory corruption was resolved when using fmt_int() improperly,
	   which was the case when a list of bad blocks was written out with -b. Thanks to Marc Thomas for reporting and debugging.
	  A segfault with the graph with reverse direction copies was also fixed as well as improved flexibility to compile ddr_crypt
	   plugin with incomplete support for new insns.

* Wed Sep  9 2015 Lawrence R. Rogers <lrr@cert.org> - 1.99-1
* Release 1.99-1
	Version 1.99 brings updates to the ddr_crypt plugin: It adds hardware
	acceleration for ARMv8 CPUs/SOCs (even if in 32bit mode) -- this is a 10x
	speedup on AES en/decryption operations. (An Cortex-A57 at 2.1GHz (Exy7420)
	does ~1GB/s with AES128-CTR.) The ddr_crypt plugin xattr support has been
	extended and it has an option to process openSSL compatible Salted__ files. A
	bug in CTR initialization has been fixed. The main program sees improved write
	error retry logic and better fault injection logic (support for ranges, using
	absolute positions). There are now more variants of Android binaries.

* Sat May 30 2015 Lawrence R. Rogers <lrr@cert.org> - 1.98-1
* Release 1.98-1
	It has a few improvements such as a few cleanups, a fault injection framework for
	testing and significantly improved speed of the pseudo RNG. But the important feature
	is the addtion of a crypt plugin. You can insert it into the plugin chain to de/encrypt
	data using the AES family of algorithms. (More are planned for the future.) You can use
	128/192/256 bit keys and optionally use a higher number of rounds to have an increased
	security margin. Keys (and IVs) can be generated, saved, retrieved or generated from
	password and salt. Please be aware that despite diligent testing this is a new plugin --
	so be prepared that there will be some changes and bugfixes to it in the near future.
	
* Sat Aug  9 2014 Lawrence R. Rogers <lrr@cert.org> - 1.46-1
* Release 1.46-1
	ddr_hash now supports calculating HMACS instead of plain hashes. The hash calculation
	has been cleaned up a bit. When a seed val of 0 is passed on the command line, additional
	randomness is created using the rdrand() command on x86/x86-64 (if available).

	(2014-06-27) A vulnerability in most implementations of lzo decompression has been
	reported. The liblzo2 library (up to and including v 2.06) used by the ddr_lzo plugin
	(until dd_rescue-1.45) is affected. You need i to feed specially crafted compressed
	data in blocks of 16MB or larger to the decompressor on 32bit platforms to exploit it,
	see the report for more details. (This issue has ID LMS-20140616-1/ CVE-2014-4607.)
	The man page ddr_lzo advises to be careful when feeding data from untrusted sources
	to the decompressor; it seems that this advice has been wise. Fortunately, ddr_lzo
	does not normally feed such large blocks to the decompressor; you'd need to manually
	increase the soft block size to at least 8MB and ignore a warning to trigger this issue
	with dd_rescue. But it is possible.  So here's my advice:

	Update liblzo2 to 2.07 (or a fixed 2.06 version) which has this issue fixed (your Linux
	distributor should provide this very soon). This is enough to fix the issue, as the
	ddr_lzo plugin of dd_rescue does dynamically link against liblzo2, except for Android.
	If using my provided Android binaries, redownload and reinstall the libddr_lzo.so binary
	(now with version number 1.45a), which has been compiled against liblzo2.a v 2.07 or
	better use the binaries from 1.46.  Be careful with media consumption -- ffmpeg/mplayer
	seems to be badly affected by this issue, even on 64bit platforms.

* Tue May 27 2014 Lawrence R. Rogers <lrr@cert.org> - 1.45-1
* Release 1.45-1
	ddr_hash received a bugfix (sha512/sha384 could overflow a buffer).
	It gained support for sha1 hash.
	ddr_hash can now conveniently retrieve (and check) and store hashes in xattrs and md5sum/sha256sum/... style files.
	A new null plugin (ddr_null) was added.

* Fri May 23 2014 Lawrence R. Rogers <lrr@cert.org> - 1.44-1
* Release 1.44-1
	The plugin libddr_MD5.so (short ddr_MD5) has been renamed to ddr_hash, reflecting that we also support sha1, sha256,
		sha224, sha512, sha384 now. Checks have been added to the test suite and the documentation been updated accordingly.

* Tue May 20 2014 Lawrence R. Rogers <lrr@cert.org> - 1.43-1
* Release 1.43-1
	The main feature of 1.43 is the new lzo plugin. It de/compresses data
	using the lzo algorithms, which are very fast to decompress and most
	versions are also fast to compress (at somewhat moderate compression
	levels). The plugin supports many of dd_rescue's features, such
	as skipping bad blocks (encoding sparseness/holes into the output)
	as well as appending. It also continues on errors (skipping a whole
	block if nodiscard is NOT given) and allows to search for valid lzo
	block headers if sync is lost. fuzz testing has been done to support
	reliability. A man page ddr_lzo(1) has been created.

	The plugin interface has been enhanced to support ddr_lzo; the MD5 plugin
	has also seen some work beyond just refactoring: It supports the parameter
	output/outfd= now and supports all type of holes that can be generated in
	a chain with ddr_lzo now.

	Some minor improvements (docu, messages) and bug fixes have been
	applied. There also is a new ARMv8 (AArch64 aka ARM64) optimized
	routine to detect zero-blocks.

* Thu Mar 06 2014 Lawrence R. Rogers <lrr@cert.org> - 1.42.1-1
* Release 1.42.1-1
	1.42.1 contains a fix for a sublety how we set up a handler for
	SIGILL and return with longjmp to detect the supported instruction
	sets of the CPU -- we need to manually reset the process' signal mask,
	otherwise a second failed probe would abort.

* Mon Mar 03 2014 Lawrence R. Rogers <lrr@cert.org> - 1.42-1
* Release 1.42-1
	1.42 brings the possibility to load plugins to analyze or transform data
	before it's written to the output file(s). A plugin to calculate the MD5
	hash is provided. posix_fadvise() is used if available (optimization) and
	dd_rescue now only provides a short usage info rather than the long help
	text on wrong parameters.

* Tue Feb 25 2014 Lawrence R. Rogers <lrr@cert.org> - 1.41-1
* Release 1.41-1
	There has been a lot of internal refactoring that improves the detection of CPU
	features (at runtime) and libc/compiler features (at build time). One result is
	that this version supports building against the Android NDK. (armv7l binaries
	built against Android API 17 (aka 4.2) libc can be found below in the download
	section.) Another consequence is that AVX2 support is now enabled (for saving
	CPU cycles on sparse block detection). A few minor bugs have been addressed
	(the most serious one a harmless off-by-one on determining the size of a
	block device). Number formatting is more consistent now. There also a new
	option -u/--rmvtrim that deletes the created file again and issues a fstrim
	on the filesystem -- good if you filled the empty space of a filesystem with
	zeros for data protection and SSD refreshment.

* Sat Feb 15 2014 Lawrence R. Rogers <lrr@cert.org> - 1.40.1-1
* Release 1.40.1-1
	It just has one patch to fix the SSE2 detection on i386 -- the old code would end in an endless loop ...

* Thu Aug 08 2013 Lawrence R. Rogers <lrr@cert.org> - 1.40-1
* Release 1.40-1
	It brings copying of extended attributes (with -p/--preserve).	It doubles the default soft
	block size for buffered IO, but brings sparse write optimization for half-empty blocks.
	It also optimizes copying by using the first write to get rid off odd file offsets.  It
	also adds a lot more test cases to make check.

* Thu Aug 08 2013 Lawrence R. Rogers <lrr@cert.org> - 1.39-1
* Release 1.39-1
	It fixes an issue where a copied file could be appended zeros if hardblocksize copy was used
	(e.g. b/c hardbs==softbs, bnc #833765). There's also a bit better ARM asm optimization,
	yielding a ~15% performance increase. There's also a help/manpage clarification that
	syncfreq actually is a size. And we use autoconf now to determine the target system
	features. Default build target now uses libdl.

* Fri Aug 02 2013 Lawrence R. Rogers <lrr@cert.org> - 1.38-1
* Release 1.38-1
	Improving SSE sparse detection performance (by 40%), adding a testcase for the 1.35/1.36
	bug and run it in make check. There's even an AVX version, but it's not enabled by
	default, as it's untested. --force/-f now allows to ignore a non-zero output position
	on non-seekable output and the curr.rate and ETA calculations have improved a bit.

* Thu Aug 01 2013 Lawrence R. Rogers <lrr@cert.org> - 1.37-1
* Release 1.37-1
	Fixing an issue with SSE2 sparse detection, which could spuriously detect zero-filled
	blocks and thus result in corrupted copies if option -a was used. (This would happen for
	blocks that had no bytes with the uppermost bit set, such as e.g. ASCII text.) Embarassing!
	Also fixed issues on big-endian machines (although these were inconsequential for dd_rescue).

* Wed Jul 24 2013 Lawrence R. Rogers <lrr@cert.org> - 1.36-1
* Release 1.36-1
	It fixes an overflow issue with the number output for long running
	dd_rescue processes. SSE2 is now also enabled in x86 (32bit, with runtime detection) and
	an optimized ARM version (assembler yeah!) to find zero blocks was added.

* Wed Jul 17 2013 Lawrence R. Rogers <lrr@cert.org> - 1.35-1
* Release 1.35-1
	It had some improvements on the output that it prints -- beyond internal improvements it introduces
	colours to the output unless the terminal type is clearly dumb; there is also an option to control this.
	Numbers are highlighted for readability. Output is rate limited (10/s). 1.35 also brings a simple
	rewrite logic for handling write errors. There's an SSE2 optimized version to find
	zero blocks for sparse writing. 

* Thu Jul 04 2013 Lawrence R. Rogers <lrr@cert.org> - 1.34-1
* Release 1.34-1
	This version provides better support for various *nix systems (specifically had a few fixes for FreeBSD),
	better compatibility with compilers (clang and g++ and clang++). It can now also load libfallocate at runtime (libdl)
	and detects a few more fatl write errors as such. 

* Tue Apr 2 2013 Lawrence R. Rogers <lrr@cert.org> - 1.33-1
* Release 1.33-1
	This version brings long options, a new double overwrite mode (-2) and a man page.

* Sun Feb 10 2013 Lawrence R. Rogers <lrr@cert.org> - 1.32-1
* Release 1.32-1
	This version has a new option -x to append to the output file and you can specify -Y (multiple times if you wish so) to write the same data
	 to secondary output files.

* Sun Feb 03 2013 Lawrence R. Rogers <lrr@cert.org> - 1.31-1
* Release 1.31-1
	This version brings a few tiny improvements in the output (such as displaying the total elapsed time in the summary as opposed to ETA of 0,
	 and the amount of data really written with option -W). But importantly, it has the new mode of triple overwriting of data (options -3 and -4),
	 with random numbers, inverse random numbers, new random numbers (only for -4) and zeros, this way allowing paranoia-safe deletion of information.

* Fri Jan 25 2013 Lawrence R. Rogers <lrr@cert.org> - 1.30-1
* Release 1.30-1
	Version 1.30 (2013-01-25) brought a fix for outputting data to stdout and a fix for a possible double free operation (introduced in 1.29).
	 The message formatting has been streamlined a bit. The PRNG can now be initialized from a file (e.g. -Z /dev/urandom).
	 The program now can also avoid writing to a target block if the target block already has the same data (option -W).
	 Think of SSDs or other devices where you want to avoid writes.

* Tue Jan 22 2013 Lawrence R. Rogers <lrr@cert.org> - 1.29-1
* Release 1.29-1
	In Version 1.29 (2013-01-22) a bug was fixed, where the last bytes where not copied corrected if hardbs == softbs. 1.29 also brings a number
	 of new features; the ability to write the same (softbs sized) block again and again (option -R, automatically set if infile is /dev/zero),
	 the ability to limit transfer size such that the outfile won't be enlarged (-M) and the possibility to use userspace random numbers (libc/frandom)
	 to fill files with random data (options -z and -Z). Last not least, OBS also builds .deb binaries for Ubu12.04 / Deb6 now.

* Sun May 20 2012 Hans Ulrich Niedermann <hun@n-dimensional.de> - 1.28-1
- Use mktemp based BuildRoot
- Ship file FAQ.dd_rhelp
- Update to dd_rescue-1.28 and dd_rhelp-0.3.0

* Fri Jan 13 2012 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.23-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_17_Mass_Rebuild

* Tue Feb 08 2011 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.23-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_15_Mass_Rebuild

* Thu Nov 18 2010 Jussi Lehtola <jussilehtola@fedoraproject.org> - 1.23-1
- Update to 1.23.

* Thu Nov 18 2010 Jussi Lehtola <jussilehtola@fedoraproject.org> - 1.22-1
- Update to 1.22.

* Fri Jul 24 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.14-10
- Rebuilt for https://fedoraproject.org/wiki/Fedora_12_Mass_Rebuild

* Tue Feb 24 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.14-9
- Rebuilt for https://fedoraproject.org/wiki/Fedora_11_Mass_Rebuild

* Wed Jul 16 2008 Tom "spot" Callaway <tcallawa@redhat.com> - 1.14-8
- fix license tag

* Mon Feb 25 2008 Andreas Thienemann <andreas@bawue.net> - 1.14-7
- Remove the obsoletes flag as we're shipping ddrescue in parallel.

* Mon Feb 11 2008 Andreas Thienemann <andreas@bawue.net> - 1.14-6
- Updated to dd_rescue 1.14 and dd_rhelp 0.1.2

* Wed Mar 07 2007 Andreas Thienemann <andreas@bawue.net> - 1.12-6
- Fixed the patch from 1.12-5

* Wed Mar 07 2007 Andreas Thienemann <andreas@bawue.net> - 1.12-5
- Fixed tail warning about deprecated argument. Thanks to Jason Farrell 
  for the patch.

* Fri Nov 10 2006 Andreas Thienemann <andreas@bawue.net> - 1.12-4
- Added dist-tag

* Fri Nov 10 2006 Andreas Thienemann <andreas@bawue.net> - 1.12-3
- *bump*

* Fri Nov 10 2006 Andreas Thienemann <andreas@bawue.net> - 1.12-2
- Fix debug package

* Fri Sep 08 2006 Andreas Thienemann <andreas@bawue.net> - 1.12-1
- Updated to 1.12
- Finally updated the package name to what we are actually shipping, 
  obsolete old one.
- Included dd_rhelp

* Thu Apr  7 2005 Michael Schwendt <mschwendt[AT]users.sf.net>
- rebuilt

* Sun Sep  5 2004 Marius L. Jøhndal <mariuslj at ifi.uio.no> - 0:1.10-0.fdr.1
- Updated to 1.10.

* Sat Dec 13 2003 Marius L. Jøhndal <mariuslj at ifi.uio.no> - 0:1.03-0.fdr.1
- Updated to 1.03.
- Minor editing of description.

* Mon Sep 29 2003 Marius L. Jøhndal <mariuslj at ifi.uio.no> - 0:1.02-0.fdr.1
- Initial RPM release.

